var $$users = $('users').view({

  templateUrl: './users.html',

  state: {users: []},

  loadUsers: function () {
    var self = this
    this.setState({isLoading: true})
    $.getJSON(this.props.api)
      .done(function (users) {
        self.setState({users: users})
      })
      .fail(function (err) {
        console.error(err)
      })
      .always(function () {
        self.setState({isLoading: false})
      })
  },

  init: function () {
    this.loadUsers()
  },

  afterRender: function ($el) {
    $el.find('.input-edit').focus()
  },

  events: {
    'click .js-edit': 'editHandler',
    'keydown .input-edit': 'inputEditHandler',
    'focusout .input-edit': function ($input) {
      var users = this.getState().users
      users[$input.data('index')].edit = false
      this.setState({users: users})
    }
  },

  remove: function (user) {
    var users = this.getState().users
    var index = users.indexOf(user)
    users.splice(index, 1)
    this.setState({users: users})
  },

  submitHandler: function ($form, event) {
    event.preventDefault()
    var self = this
    var username = $form.find('.username').val()
    var email = $form.find('.email').val()
    var users = this.getState().users
    var user = {
      name: username,
      email: email,
      sending: true
    }
    users.push(user)
    this.setState({users: users})
    var index = users.length - 1

    $.post(this.props.api, user)
      .done(function (response) {

      })
      .fail(function () {

      })
      .always(function () {
        user.sending = false
        users = self.getState().users
        users[index] = user
        self.setState({users: users})
      })
  },

  moveUp: function (user) {
    var users = this.getState().users
    var index = users.indexOf(user)
    var newIndex = index === 0
      ? users.length - 1
      : index - 1
    users.splice(index, 1)
    users.splice(newIndex, 0, user)
    this.setState({users: users})
  },

  moveDown: function (user) {
    var users = this.getState().users
    var index = users.indexOf(user)
    var newIndex = index === users.length - 1
      ? 0
      : index + 1
    users.splice(index, 1)
    users.splice(newIndex, 0, user)
    this.setState({users: users})
  },

  editHandler: function ($btn, event) {
    var users = this.getState().users
    users[$btn.data('index')].edit = true
    this.setState({users: users})
  },

  inputEditHandler: function ($input, event) {
    if (event.which === 13) {
      var username = $input.val()
      var index = $input.data('index')
      var users = this.getState().users
      users[index].name = username
      users[index].edit = false
      this.setState({users: users})
    }
  },

  testHandler: function ($event) {
    console.log('TEST HANDLER', $event)
  }

})